<?xml version="1.0" encoding="Shift_JIS"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

	<xsl:output method="text" encoding="Shift_JIS"/>

	<!-- CSV̍i -->
	<xsl:template match="/">
		<xsl:text>====ᔽ̌oꂽ\[Xt@C====&#xd;&#xa;</xsl:text>
		<xsl:text>tpX,[NXy[X΃pX&#xd;&#xa;</xsl:text>
		<xsl:apply-templates select="/ResultsSession/Locations/Loc"/>
		<xsl:text>&#xd;&#xa;</xsl:text>
		
		<xsl:text>====ÓI̓|[g====&#xd;&#xa;</xsl:text>
		<xsl:text>쐬,t@C,s,[ID,dvxx,bZ[W,tpX&#xd;&#xa;</xsl:text>
		<xsl:apply-templates select="/ResultsSession/CodingStandards/StdViols"/>
		<xsl:text>&#xd;&#xa;</xsl:text>
		
		<!-- }ꂽbZ[W̏ڍ -->
		<xsl:text>====}ꂽbZ[W̏ڍ====&#xd;&#xa;</xsl:text>
		<xsl:text>}s[U,t@C,[ID,}bZ[W,R&#xd;&#xa;</xsl:text>
		<xsl:apply-templates select="/ResultsSession/CodingStandards/Supps/Supp"/>
		
	</xsl:template>


	<!-- t@CP[V -->
	<xsl:template match="/ResultsSession/Locations/Loc">
		<xsl:call-template name="FileLocation"/>
	</xsl:template>
	
	<!-- t@C̐΃pXƃ[NXy[XpXo -->
	<xsl:template name="FileLocation">
		<xsl:value-of select="@fsPath"/>,<xsl:value-of select="@loc"/><xsl:text>&#xd;&#xa;</xsl:text>
	</xsl:template>


	<!-- ÓI -->
	<xsl:template match="/ResultsSession/CodingStandards/StdViols">
		<!-- R[fBO[ -->
		<xsl:for-each select="./StdViol">
			<xsl:call-template name="StaticAnalysis">
				<xsl:with-param name="loc_workspace" select="@locFile"/>
			</xsl:call-template>
		</xsl:for-each>

		<!-- oOT -->
		<xsl:for-each select="./FlowViol">
			<xsl:call-template name="StaticAnalysis">
				<xsl:with-param name="loc_workspace" select="@locFile"/>
			</xsl:call-template>
		</xsl:for-each>
	</xsl:template>
	
	<!-- 1̐ÓI͌ʂo -->
	<xsl:template name="StaticAnalysis">
		<xsl:param name="loc_workspace"/>
		<xsl:value-of select="@auth"/>,<xsl:value-of select="@locFile"/>,<xsl:value-of select="@ln"/>,<xsl:value-of select="@rule"/>,<xsl:value-of select="@sev"/>,<xsl:text>&quot;</xsl:text>
		<xsl:call-template name="quote">
			<xsl:with-param name="text" select="@msg"/>
		</xsl:call-template>
		<xsl:text>&quot;</xsl:text>
		<xsl:for-each select="/ResultsSession/Locations/Loc">
			<xsl:if test="@loc=$loc_workspace">
				<xsl:text>,</xsl:text><xsl:value-of select="@fsPath"/>
			</xsl:if>
		</xsl:for-each>
		<xsl:text>&#xd;&#xa;</xsl:text>
	</xsl:template>

	<!-- CSV֏o͂邽߁ANI[g -->
	<xsl:template name="quote">
		<xsl:param name="text"/>
		<xsl:choose>
			<xsl:when test="contains($text, '&quot;')">
				<xsl:value-of select="substring-before($text, '&quot;')"/>
				<xsl:text>&quot;&quot;</xsl:text>
				<xsl:call-template name="quote">
					<xsl:with-param name="text" select="substring-after($text, '&quot;')"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<xsl:value-of select="$text"/>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!-- } -->
	<xsl:template match="/ResultsSession/CodingStandards/Supps/Supp">
		<xsl:call-template name="Suppressions"/>
	</xsl:template>
	
	<!-- }o -->
	<xsl:template name="Suppressions">
		<xsl:value-of select="@suppAuth"/>,<xsl:value-of select="@suppLoc"/>,<xsl:value-of select="@suppRule"/>,<xsl:value-of select="@suppMsg"/>,<xsl:value-of select="@suppRsn"/><xsl:text>&#xd;&#xa;</xsl:text>
	</xsl:template>

</xsl:stylesheet>
